﻿;==========================================================================================================================================================
; Coloured header control.By srod.Purebasic 4.Windows.
;==========================================================================================================================================================

Procedure ColourListIconGadgetHeading(Handle.i,  Message.i,  Wparam.i,  Lparam.i)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------

  Protected hdi.hd_item
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  ResultCode.i = CallWindowProc_(Program\OldListIconCallback,  Handle.i,  Message.i,  Wparam.i,  Lparam.i)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  Select Message.i
      
    Case #WM_NOTIFY
      
      *pnmh.NMHDR = Lparam.i
      
      ; Get handle to ListIcon header control
      
      If *pnmh\code = #NM_CUSTOMDRAW
        
        *pnmcd.NMCUSTOMDRAW = Lparam.i
        
        ; Determine drawing stage
        
        Select *pnmcd\dwDrawStage
            
          Case #CDDS_PREPAINT
            
            ResultCode.i = #CDRF_NOTIFYITEMDRAW
            
          Case #CDDS_ITEMPREPAINT
            
            TextString.s = GetGadgetItemText(GetDlgCtrlID_(Handle.i), -1, *pnmcd\dwItemSpec) ; Get header text.
            
            If *pnmcd\uItemState & #CDIS_SELECTED  ; Check button state.
              
              ; DrawFrameControl_(*pnmcd\hdc,  *pnmcd\rc,  #DFC_BUTTON,  #DFCS_BUTTONPUSH | #DFCS_PUSHED)
              
              ; DrawFrameControl_(*pnmcd\hdc,  *pnmcd\rc,  #DFC_BUTTON,  #DFCS_FLAT)
              
              DrawFrameControl_(*pnmcd\hdc,  *pnmcd\rc,  #DFC_BUTTON,  #DFC_MENU)
              
              InflateRect_(*pnmcd\rc, -1, -1) ; Offset text because of the selected button.
              
              
              
; BOOL DrawFrameControl(
;   _In_  HDC hdc,
;   _In_  LPRECT lprc,
;   _In_  UINT uType,
;   _In_  UINT uState
; );
            Else
              
              DrawFrameControl_(*pnmcd\hdc,  *pnmcd\rc,  #DFC_BUTTON,  #DFCS_BUTTONPUSH)
              
            EndIf
            
            *pnmcd\rc\bottom -2
            
            *pnmcd\rc\right - 2  ; Draw background.
            
            SetBkMode_(*pnmcd\hdc, #TRANSPARENT)
            
            FillRect_(*pnmcd\hdc,  *pnmcd\rc,  Program\BackBrush)
            
            SetTextColor_(*pnmcd\hdc,  Program\FrontBrush)
            
            *pnmcd\rc\top + 2
            
            InflateRect_(*pnmcd\rc, -5, 0)
            
            If *pnmcd\rc\right > *pnmcd\rc\left
              
;             DrawText_(*pnmcd\hdc,  @TextString.s,  Len(TextString.s),  *pnmcd\rc,  #DT_CENTER | #DT_VCENTER | #DT_END_ELLIPSIS)
              
              DrawText_(*pnmcd\hdc,  @TextString.s,  Len(TextString.s),  *pnmcd\rc,  #DT_LEFT   | #DT_VCENTER | #DT_END_ELLIPSIS)
              
            EndIf
            
            ResultCode.i = #CDRF_SKIPDEFAULT
            
        EndSelect
        
      EndIf
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------

  ProcedureReturn ResultCode.i
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 82
; FirstLine = 75
; Folding = -
; EnableXP