﻿;==========================================================================================================================================================
; Format menu text and shortcut strings to nice length
;==========================================================================================================================================================

Procedure.s FormatMenu(HeadingString.s, ShortcutString.s, FieldLen.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  HeadingStringLen.i = Len(HeadingString.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SpaceStringLength.i    = FieldLen.i - HeadingStringLen.i
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If SpaceStringLength.i > 1
    
    NewHeadingString.s = HeadingString.s + ": " + Chr(9) + Space(SpaceStringLength.i)
    
  Else
    
    NewHeadingString.s = HeadingString.s + ": "
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ShortcutString.s  = ReplaceString(ShortcutString.s, "Keyboard Shortcut: ", "", 1)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  ProcedureReturn NewHeadingString.s  + ShortcutString.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 24
; FirstLine = 14
; Folding = -
; EnableXP