﻿;==========================================================================================================================================================
; Change the time for alarm checks. Global  ; 1000 = 1 second
;==========================================================================================================================================================

Procedure ChangeAlarmCheckTime()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  AlarmCheckSelection.i = GetGadgetState(#Gadget_AppointmentMuncher_SnoozePeriod)
 
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select  AlarmCheckSelection.i
     
    Case  0 :                                  RunFlag.i = 0   ;  Alarm checking off
    
    Case  1 : TimePeriod.i =   5 * 60 * 1000 : RunFlag.i = 1   ;  5 Minutes
    
    Case  2 : TimePeriod.i =  10 * 60 * 1000 : RunFlag.i = 1   ; 10 Minutes
    
    Case  3 : TimePeriod.i =  30 * 60 * 1000 : RunFlag.i = 1   ; 30 Minutes
    
    Case  4 : TimePeriod.i =  40 * 60 * 1000 : RunFlag.i = 1   ; 40 Minutes
    
    Case  5 : TimePeriod.i =  50 * 60 * 1000 : RunFlag.i = 1   ; 50 Minutes
    
    Case  6 : TimePeriod.i =  60 * 60 * 1000 : RunFlag.i = 1   ;  1 Hour
    
    Case  7 : TimePeriod.i = 120 * 60 * 1000 : RunFlag.i = 1   ;  2 Hours
    
    Case  8 : TimePeriod.i = 180 * 60 * 1000 : RunFlag.i = 1   ;  3 Hours
    
    Case  9 : TimePeriod.i = 240 * 60 * 1000 : RunFlag.i = 1   ;  4 Hours
    
    Case 10 : TimePeriod.i = 300 * 60 * 1000 : RunFlag.i = 1   ;  5 Hours
    
    Case 11 : TimePeriod.i = 360 * 60 * 1000 : RunFlag.i = 1   ;  6 Hours
    
    Case 12 : TimePeriod.i = 420 * 60 * 1000 : RunFlag.i = 1   ;  7 Hours
    
    Case 13 : TimePeriod.i = 480 * 60 * 1000 : RunFlag.i = 1   ;  8 Hours
  
  EndSelect
 
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
 
  Select RunFlag.i
     
    Case 0
     
      If KillTimer_(WindowID(#Window_AppointmentMuncher), #Event_Alarm_Check) <> 0
       
        ; Debug "Timer killed"
       
      EndIf
     
    Case 1
     
      If KillTimer_(WindowID(#Window_AppointmentMuncher), #Event_Alarm_Check) <> 0
       
        ; Debug "Timer killed"
       
      EndIf
     
      If SetTimer_(WindowID(#Window_AppointmentMuncher), #Event_Alarm_Check, TimePeriod.i, @CheckAppointments()) <> 0
       
        ; Debug "Timer started"
       
      EndIf
     
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
 
EndProcedure

;------------------------------------------------------------------------------------------------
; Check if the alarm routine needs to be run. Set to 10 minutes
;------------------------------------------------------------------------------------------------
;
  
; UINT_PTR WINAPI SetTimer(
;   _In_opt_  HWND hWnd,
;   _In_      UINT_PTR nIDEvent,
;   _In_      UINT uElapse,
;   _In_opt_  TIMERPROC lpTimerFunc
; );
  
; BOOL WINAPI KillTimer(
;   _In_opt_  HWND hWnd,
;   _In_      UINT_PTR uIDEvent
; );

; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 70
; FirstLine = 62
; Folding = -
; EnableXP