﻿;========================================================================================================================================
; Show the comment for an alarm when the alarm list is clicked on
;========================================================================================================================================

Procedure ShowAppointmentAlarmComment()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  CurrentAlarmLine.i = GetGadgetState(#Gadget_AppointmentAlarm_Appointments)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CurrentAlarmLine.i <> -1
    
    AlarmComment.s = GetGadgetItemText(#Gadget_AppointmentAlarm_Appointments, CurrentAlarmLine.i, Program\AlarmCommentColumn)
    
    SetGadgetText(#Gadget_AppointmentAlarm_Comment, AlarmComment.s)
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  #InfoStringNoAlarmComment)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 33
; Folding = -
; EnableXP