﻿;==========================================================================================================================================================
; Save all the program options whenever you need to
;==========================================================================================================================================================

Procedure SaveProgramOptions()
  
;   ;------------------------------------------------------------------
;   ; These options are set in toggle procedures, no need to duplicate here
;   ;------------------------------------------------------------------
;   
;   Setup\TitleClock    =          GetGadgetState(#Gadget_AppointmentSetup_TitleClock)
;   
;   Setup\StickyWindow  =          GetGadgetState(#Gadget_AppointmentSetup_StickyWindow)
;   
;   Setup\ToolTips      =          GetGadgetState(#Gadget_AppointmentSetup_ToolTips)
;   
;   Setup\ScreenSnap    =          GetGadgetState(#Gadget_AppointmentSetup_ScreenSnap)
;     
;   Setup\AutoArchive   =          GetGadgetState(#Gadget_AppointmentSetup_AutoArchive)
;   
;   Setup\EmailAlarm    =          GetGadgetState(#Gadget_AppointmentSetup_EmailAlarm)
  
;   ;------------------------------------------------------------------------------------------------
;   ; Get the following two values from the main form as they are not set here
;   ;------------------------------------------------------------------------------------------------
;   
;   Setup\StartupDates  =          GetGadgetState(#Gadget_AppointmentSetup_StartupDates)
;   
;   Setup\SnoozePeriod  =          GetGadgetState(#Gadget_AppointmentSetup_SnoozePeriod)
;   
;   Setup\AlarmSound    =          GetGadgetState(#Gadget_AppointmentSetup_AlarmSound)
;   
;   Setup\LastSearch    = RepQuote(GetGadgetText(#Gadget_AppointmentSetup_LastSearch))
  
;   ;------------------------------------------------------------------------------------------------
;   ; 
;   ;------------------------------------------------------------------------------------------------
;   
;   Setup\ServerName    = RepQuote(GetGadgetText(#Gadget_AppointmentSetup_ServerName))
;   
;   Setup\PortNumber    = RepQuote(GetGadgetText(#Gadget_AppointmentSetup_PortNumber))
;   
;   Setup\UserName      = RepQuote(GetGadgetText(#Gadget_AppointmentSetup_UserName))
;   
;   Setup\Password      = RepQuote(GetGadgetText(#Gadget_AppointmentSetup_Password))
;   
;   Setup\NeedSsl       = RepQuote(GetGadgetText(#Gadget_AppointmentSetup_NeedSsl))
;   
;   Setup\EmailAddress  = RepQuote(GetGadgetText(#Gadget_AppointmentSetup_EmailAddress))
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s = "UPDATE Setup SET"
  
  ;------------------------------------------------------------------------------------------------
  ; These options are set in toggle procedures, no need to duplicate here
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s + "   TitleClock = '"     + Str(Setup\TitleClock)
  
  QueryString.s + "', StickyWindow = '"   + Str(Setup\StickyWindow)
  
  QueryString.s + "', ToolTips = '"       + Str(Setup\ToolTips)
  
  QueryString.s + "', ScreenSnap = '"     + Str(Setup\ScreenSnap)
  
  QueryString.s + "', AutoArchive = '"    + Str(Setup\AutoArchive)
  
  QueryString.s + "', EmailAlarm = '"     + Str(Setup\EmailAlarm)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s + "', StartupDates = '"   + Str(Setup\StartupDates)
  
  QueryString.s + "', SnoozePeriod = '"   + Str(Setup\SnoozePeriod)
  
  QueryString.s + "', AlarmSound = '"     + Str(Setup\AlarmSound)
  
  QueryString.s + "', LastSearch = '"     +     Setup\LastSearch
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s + "', ServerName = '"     +     Setup\ServerName
  
  QueryString.s + "', PortNumber = '"     +     Setup\PortNumber
  
  QueryString.s + "', UserName = '"       +     Setup\UserName
  
  QueryString.s + "', Password = '"       +     Setup\Password
  
  QueryString.s + "', NeedSsl = '"        +     Setup\NeedSsl
  
  QueryString.s + "', EmailAddress = '"   +     Setup\EmailAddress
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s + "' Where SetupRecord = '1'" 
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
    
    SetInfoBarArea("Headings", "Info", #InfoStringSetupSaveOkay)
    
  Else
    
    SetInfoBarArea("Headings", "Error", #InfoStringSetupSaveError + DatabaseError(), "SaveProgramOptions")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 58
; FirstLine = 9
; Folding = -
; EnableXP