﻿;========================================================================================================================================
; Cancel the current appointment. Sets it as a finished task
;========================================================================================================================================

Procedure CancelCurrentAppointment()
  
  ;------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------
  
  NumberOfItems.i = CountGadgetItems(#Gadget_AppointmentAlarm_Appointments) - 1
  
  ;------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------
  
  For CancelLoop.i = NumberOfItems.i To 0 Step -1
    
    ;----------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------
    
    If GetGadgetItemState(#Gadget_AppointmentAlarm_Appointments, CancelLoop.i) & #PB_ListIcon_Selected
      
      ;--------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------
      
      appName.s   = GetGadgetItemText(#Gadget_AppointmentAlarm_Appointments, CancelLoop.i, Program\NameColumn)
      
      appRecord.s = GetGadgetItemText(#Gadget_AppointmentAlarm_Appointments, CancelLoop.i, Program\AlarmRecordColumn)
      
      ;--------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------
      
      If RecordNumber.s <> ""
        
        ;------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------
        
        QueryString.s = "UPDATE Appointments "
        
        QueryString.s + "SET appStatus = 'Finished appointment' "
        
        QueryString.s + "WHERE appRecord = '" + appRecord.s + "'"
        
        ;------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
          
          RemoveGadgetItem(#Gadget_AppointmentAlarm_Appointments, CancelLoop.i)
          
          SetInfoBarArea("Headings",  "Info",  #InfoStringCancelled  + appName.s)
          
        Else
          
          SetInfoBarArea("Headings",  "Error",  #InfoStringUpdateFailed  + DatabaseError())
          
        EndIf
        
        ;------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Error",  #InfoStringNoRecord)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------
      
    Else
      
      ; SetInfoBarArea("Headings", "Info",  #InfoStringNotSelected)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------
    
  Next CancelLoop.i
  
  ;------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------
  
  If CountGadgetItems(#Gadget_AppointmentAlarm_Appointments)  = 0
    
    CloseMyWindow(#Window_AppointmentAlarm)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 105
; FirstLine = 69
; Folding = -
; EnableXP