﻿;==========================================================================================================================================================
; Delete all the selected appointments
;==========================================================================================================================================================

Procedure DeleteSelectedAppointments()
  
  ;------------------------------------------------------------------------------------------------
  ; Check if the alarm checker is running first
  ;------------------------------------------------------------------------------------------------
  
  If Program\DontCheck <> 1
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\DontCheck = 1
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    NumberOfItems.i = CountGadgetItems(#Gadget_AppointmentMuncher_Appointments)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If NumberOfItems.i <> 0
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      For DeleteLoop.i = NumberOfItems.i To 0 Step -1
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If GetGadgetItemState(#Gadget_AppointmentMuncher_Appointments, DeleteLoop.i) & #PB_ListIcon_Selected
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          appProtect.s  = GetGadgetItemText(#Gadget_AppointmentMuncher_Appointments, DeleteLoop.i, Program\ProtectColumn)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If appProtect.s = "0"
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            RecordNumber.s    = GetGadgetItemText(#Gadget_AppointmentMuncher_Appointments, DeleteLoop.i, Program\RecordColumn)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            QueryString.s = "UPDATE Appointments "
            
            QueryString.s + "SET appDeleted = '1' "
            
            QueryString.s + "WHERE appRecord = '" + RecordNumber.s + "' "
            
            QueryString.s + "AND appProtect = '0'"
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
              
              SetGadgetItemData(#Gadget_AppointmentMuncher_Appointments, DeleteLoop.i, 1)
              
              RedrawWindow_(GadgetID(#Gadget_AppointmentMuncher_Appointments), 0, 0, #RDW_INVALIDATE | #RDW_ERASE)
              
              Changeicon(#Gadget_AppointmentMuncher_Appointments, DeleteLoop.i, 0, Icon\ListDeleted)
              
              SetGadgetItemText(#Gadget_AppointmentMuncher_Appointments, Program\CurrentLine, "1", Program\DeletedColumn)
              
            Else
              
              SetInfoBarArea("Headings", "Warn", #InfoStringUpdateFailed + DatabaseError(), "DeleteSelectedAppointments")
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Error", #InfoStringProtectedItem, "DeleteSelectedAppointments")
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          ; SetInfoBarArea("Headings", "Info",  #InfoStringNotSelected)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Next  DeleteLoop.i
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      PostEvent(#PB_Event_Gadget, #Window_AppointmentMuncher, #Gadget_AppointmentMuncher_Appointments, #PB_EventType_Change)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Info", #InfoStringNoneToDelete)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\DontCheck = 0
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  #InfoStringAlarmRunning)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 98
; FirstLine = 118
; Folding = -
; EnableXP