﻿;==========================================================================================================================================================
; Delete all the selected appointments
;==========================================================================================================================================================

Procedure UndeleteSelectedAppointments()
  
  ;------------------------------------------------------------------------------------------------
  ; Check if the alarm checker is running first
  ;------------------------------------------------------------------------------------------------
  
  If Program\DontCheck <> 1

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    NumberOfItems.i = CountGadgetItems(#Gadget_AppointmentMuncher_Appointments)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If NumberOfItems.i <> 0
      
      ;--------------------------------------------------------------------------------------------
      ; Clear all data on main form prior to marking deletions
      ;--------------------------------------------------------------------------------------------
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      For UndeleteDeleteLoop.i = NumberOfItems.i To 0 Step -1
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If GetGadgetItemState(#Gadget_AppointmentMuncher_Appointments, UndeleteDeleteLoop.i) & #PB_ListIcon_Selected
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          appRecord.s = GetGadgetItemText(#Gadget_AppointmentMuncher_Appointments, UndeleteDeleteLoop.i, Program\RecordColumn)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          QueryString.s = "UPDATE Appointments "
          
          QueryString.s + "SET appDeleted = '0' "
          
          QueryString.s + "WHERE appRecord = '" + appRecord.s + "'"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
            
            SetGadgetItemData(#Gadget_AppointmentMuncher_Appointments, UndeleteDeleteLoop.i, 0)
            
            RedrawWindow_(GadgetID(#Gadget_AppointmentMuncher_Appointments), 0, 0, #RDW_INVALIDATE | #RDW_ERASE)
            
            Changeicon(#Gadget_AppointmentMuncher_Appointments, UndeleteDeleteLoop.i, 0, Icon\ListDeleted)
            
            SetGadgetItemText(#Gadget_AppointmentMuncher_Appointments, Program\CurrentLine, "0", 7)
            
          Else
            
            SetInfoBarArea("Headings", "Error", #InfoStringUpdateFailed + DatabaseError(), "UndeleteSelectedAppointments")
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          ; SetInfoBarArea("Headings", "Info",  #InfoStringNotSelected)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Next  UndeleteDeleteLoop.i
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      PostEvent(#PB_Event_Gadget, #Window_AppointmentMuncher, #Gadget_AppointmentMuncher_Appointments, #PB_EventType_Change)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Info", #InfoStringListEmpty)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
      
    SetInfoBarArea("Headings",  "Warn",  #InfoStringAlarmRunning)
      
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 72
; Folding = -
; EnableXP