﻿;========================================================================================================================================
; List all appointments at startup
;========================================================================================================================================

Procedure ListAppointments()
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  QueryString.s = "SELECT * FROM Appointments "
  QueryString.s + "WHERE appDate = '" + IsoDate(Program\CurrentDate, "IsoDate") + "'"
  QueryString.s + "ORDER BY appDate"
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  ItemCounter.i = 0
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  With Appointment
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      While NextDatabaseRow(Program\DatabaseHandle)
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        ItemCounter.i + 1
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        \appDate     = IsoDate(KillQuote(GetDatabaseString(Program\DatabaseHandle,  0)), "Normaldate")
        \appTime     =         KillQuote(GetDatabaseString(Program\DatabaseHandle,  1))
        \appAlarm    = IsoDate(KillQuote(GetDatabaseString(Program\DatabaseHandle,  2)), "Normaldate")
        \appCategory =         KillQuote(GetDatabaseString(Program\DatabaseHandle,  3))
        \appStatus   =         KillQuote(GetDatabaseString(Program\DatabaseHandle,  4))
        \appName     =         KillQuote(GetDatabaseString(Program\DatabaseHandle,  5))
        \appComment  =         KillQuote(GetDatabaseString(Program\DatabaseHandle,  6))
        \appDeleted  =         KillQuote(GetDatabaseString(Program\DatabaseHandle,  7))
        \appRecord   =         KillQuote(GetDatabaseString(Program\DatabaseHandle,  8))      
        ;------------------------------------------------------------------------------------------
        ; Now, off to the display routine. It must set icons, data and nicely formatted dates
        ;------------------------------------------------------------------------------------------
        DisplayListItem(ItemCounter.i, "AddMode")
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        ClearStructure(@Appointment, AppointmentData)
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
      Wend
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      FinishDatabaseQuery(Program\DatabaseHandle)
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    EndIf
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
  EndWith
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
EndProcedure



; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 46
; FirstLine = 27
; Folding = -
; EnableXP