﻿;============================================================================================================================================================
; Hide the program window now
;============================================================================================================================================================

Procedure HideProgramWindow()

  ;------------------------------------------------------------------------------------------------
  ; Minimise the program to the system tray area and set a tool tip
  ;------------------------------------------------------------------------------------------------

  Program\TrayState = #True      ; We've hidden the tray, so set the value corectly

  ;------------------------------------------------------------------------------------------------
  ; Hide the window now
  ;------------------------------------------------------------------------------------------------

  HideWindow(#Window_AppointmentMuncher, 1)

  ;------------------------------------------------------------------------------------------------
  ; Add the system tray icon now
  ;------------------------------------------------------------------------------------------------

  AddSysTrayIcon(#Systray_AppointmentMuncher_Tray, WindowID(#Window_AppointmentMuncher), ImageID(#ProgramIcon))

  ;------------------------------------------------------------------------------------------------
  ; Add a tool tip to the tray
  ;------------------------------------------------------------------------------------------------

  SysTrayIconToolTip(#Systray_AppointmentMuncher_Tray, #Program)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 28
; Folding = -
; EnableXP